//+------------------------------------------------------------------+
//| fatl adaptive smoother
//|
//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     LimeGreen
#property indicator_color2     Orange
#property indicator_color3     Gray
#property indicator_color4     LimeGreen
#property indicator_color5     Red
#property indicator_width1     4
#property indicator_width2     4
#property indicator_width3     2

//
//
//
//
//

extern double OmaLength = 25;
extern double Speed     = 3;
extern bool   Adaptive  = true;

//
//
//
//
//

double ofatl[];
double diff[];
double diffhuu[];
double diffhdd[];
double slope[];
double trend[];
double upArr[];
double dnArr[];

//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,diffhuu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,diffhdd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,diff);
   SetIndexBuffer(3,upArr);   SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,233);
   SetIndexBuffer(4,dnArr);   SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,234);
   SetIndexBuffer(5,ofatl);
   SetIndexBuffer(6,slope);
   SetIndexBuffer(7,trend);
   SetLevelValue(0,0);
   Speed = MathMax(MathMin(1.5,Speed),0.1);
   IndicatorShortName("Fatl One More Average Slope Speed"); 

return(0);
}
//+------------------------------------------------------------------+
//| FATL |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
       
   //
   //
   //
   //
   //

   for (int i=limit; i>=0; i--)
   {
      double fatl = +0.4360409450*Close[i+0]  +0.3658689069*Close[i+1]  +0.2460452079*Close[i+2]  +0.1104506886*Close[i+3]  -0.0054034585*Close[i+4]
                    -0.0760367731*Close[i+5]  -0.0933058722*Close[i+6]  -0.0670110374*Close[i+7]  -0.0190795053*Close[i+8]  +0.0259609206*Close[i+9]
                    +0.0502044896*Close[i+10] +0.0477818607*Close[i+11] +0.0249252327*Close[i+12] -0.0047706151*Close[i+13] -0.0272432537*Close[i+14]
                    -0.0338917071*Close[i+15] -0.0244141482*Close[i+16] -0.0055774838*Close[i+17] +0.0128149838*Close[i+18] +0.0226522218*Close[i+19] 
                    +0.0208778257*Close[i+20] +0.0100299086*Close[i+21] -0.0036771622*Close[i+22] -0.0136744850*Close[i+23] -0.0160483392*Close[i+24]
                    -0.0108597376*Close[i+25] -0.0016060704*Close[i+26] +0.0069480557*Close[i+27] +0.0110573605*Close[i+28] +0.0095711419*Close[i+29]
                    +0.0040444064*Close[i+30] -0.0023824623*Close[i+31] -0.0067093714*Close[i+32] -0.0072003400*Close[i+33] -0.0047717710*Close[i+34]
                    +0.0005541115*Close[i+35] +0.0007860160*Close[i+36] +0.0130129076*Close[i+37] +0.0040364019*Close[i+38];
                    ofatl[i] = iOma(fatl,OmaLength,Speed,Adaptive,i);
                    diff[i]  = ofatl[i]-ofatl[i+1];
                    
                    //
                    //
                    //
                    //
                    //
                    
                    diffhuu[i] = EMPTY_VALUE;
                    diffhdd[i] = EMPTY_VALUE;     
                    slope[i]   = slope[i+1];
                      if (diff[i] > diff[i+1]) slope[i] =  1;
                      if (diff[i] < diff[i+1]) slope[i] = -1;
                      if (slope[i]== 1) diffhuu[i] = diff[i];
                      if (slope[i]==-1) diffhdd[i] = diff[i];
                      
                      //
                      //
                      //
                      //
                      //
                      
                      trend[i] = trend[i+1];  
                         if (diff[i] > 0) trend[i] =  1;
                         if (diff[i] < 0) trend[i] = -1;
                         
                         //
                         //
                         //
                         //
                         //
                         
   }
   for (i=limit; i>=0; i--)
   {
      upArr[i] = EMPTY_VALUE;
      dnArr[i] = EMPTY_VALUE;
         if (trend[i] !=trend[i+1])
         if (trend[i] == 1)
               upArr[i] = diff[i]-iStdDevOnArray(diff,0,10,0,MODE_SMA,i);
        else   dnArr[i] = diff[i]+iStdDevOnArray(diff,0,10,0,MODE_SMA,i); 
      }
  return(0);
  }
   
//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workOma[][7];
#define F01 0
#define F02 1
#define F03 2
#define F04 3
#define F05 4
#define F06 5
#define prc 6

//
//
//
//
//

double iOma(double price, double averagePeriod, double constant, bool adaptive, int r, int s=0)
{
   if (averagePeriod <=1) return(price);
   if (ArrayRange(workOma,0) != Bars) ArrayResize(workOma,Bars); r=Bars-r-1; s *=7;
   if (r<=1) 
   {
      for (int i=0; i<6; i++) workOma[r][i  +s] = 0;
                              workOma[r][prc+s] = price;
                              return(price);
   }      
   double f01=workOma[r-1][F01+s];  double f02=workOma[r-1][F02+s];
   double f03=workOma[r-1][F03+s];  double f04=workOma[r-1][F04+s];
   double f05=workOma[r-1][F05+s];  double f06=workOma[r-1][F06+s];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = MathMin(averagePeriod,r)/2.0;
         double maxPeriod = MathMin(minPeriod*5.0,r);
         int    endPeriod = (int)MathCeil(maxPeriod);
         double tsignal   = MathAbs((price-workOma[r-endPeriod][prc+s]));
         double noise     = 0.00000000001;

            for(i=1; i<endPeriod; i++) noise=noise+MathAbs(price-workOma[r-i][prc+s]);

         averagePeriod = ((tsignal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double Kg = (2.0+constant)/(1.0+constant+averagePeriod);
      double Hg = 1.0-Kg;

      f01 = Kg * price + Hg * f01; f02 = Kg * f01 + Hg * f02; double v01 = 1.5 * f01 - 0.5 * f02;
      f03 = Kg * v01   + Hg * f03; f04 = Kg * f03 + Hg * f04; double v02 = 1.5 * f03 - 0.5 * f04;
      f05 = Kg * v02   + Hg * f05; f06 = Kg * f05 + Hg * f06; double v03 = 1.5 * f05 - 0.5 * f06;

   //
   //
   //
   //
   //

   workOma[r][F01+s] = f01;  workOma[r][F02+s] = f02;
   workOma[r][F03+s] = f03;  workOma[r][F04+s] = f04;
   workOma[r][F05+s] = f05;  workOma[r][F06+s] = f06;
   workOma[r][prc+s] = price;
return(v03);
}